- Main Page
- Modules
- Namespaces
- Classes
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# Parma_Polyhedra_Library::Determinate< PH > Class Template Reference
[C++ Language Interface]

Wraps a PPL class into a determinate constraint system interface. More...

List of all members.

## Public Member Functions
Constructors and Destructor
| Determinate (const PH &p)
| Injection operator: builds the determinate constraint system element corresponding to the base-level element `p`.
| Determinate (const Constraint_System &cs)
| Injection operator: builds the determinate constraint system element corresponding to the base-level element represented by `cs`.
| Determinate (const Congruence_System &cgs)
| corresponding to the base-level element represented by `cgs`.
| Determinate (const Determinate &y)
| Copy constructor.
| ~Determinate ()
| Destructor.
Member Functions that Do Not Modify the Domain Element
const PH & | element () const
| Returns a const reference to the embedded element.
bool | is_top () const
| Returns `true` if and only if `*this` is the top of the determinate constraint system (i.e., the whole vector space).
bool | is_bottom () const
| Returns `true` if and only if `*this` is the bottom of the determinate constraint system.
bool | definitely_entails (const Determinate &y) const
| Returns `true` if and only if `*this` entails `y`.
bool | is_definitely_equivalent_to (const Determinate &y) const
| Returns `true` if and only if `*this` and `y` are equivalent.
memory_size_type | total_memory_in_bytes () const
| Returns a lower bound to the total size in bytes of the memory occupied by `*this`.
memory_size_type | external_memory_in_bytes () const
| Returns a lower bound to the size in bytes of the memory managed by `*this`.
bool | OK () const
| Checks if all the invariants are satisfied.
Member Functions that May Modify the Domain Element
void | upper_bound_assign (const Determinate &y)
| Assigns to `*this` the upper bound of `*this` and `y`.
void | meet_assign (const Determinate &y)
| Assigns to `*this` the meet of `*this` and `y`.
void | concatenate_assign (const Determinate &y)
| Assigns to `*this` the concatenation of `*this` and `y`, taken in this order.
PH & | element ()
| Returns a reference to the embedded element.
Determinate & | operator= (const Determinate &y)
| Assignment operator.
void | swap (Determinate &y)
| Swaps `*this` with `y`.
## Friends
bool | operator== (const Determinate< PH > &x, const Determinate< PH > &y)
| Returns `true` if and only if `x` and `y` are the same domain element.
bool | operator!= (const Determinate< PH > &x, const Determinate< PH > &y)
| Returns `true` if and only if `x` and `y` are different domain elements.
## Related Functions
(Note that these are not member functions.)
std::ostream & | operator<< (std::ostream &, const Determinate< PH > &)
| Output operator.
void | swap (Parma_Polyhedra_Library::Determinate< PH > &x, Parma_Polyhedra_Library::Determinate< PH > &y)
| Specializes `std::swap`.

## Detailed Description

### template<typename PH>
class Parma_Polyhedra_Library::Determinate< PH >

Wraps a PPL class into a determinate constraint system interface.